## pocl 0.10

=== lib/kernel/cellspu/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2014 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

include("bitcode_rules")

# Use TARGET flags:
#CLANG_FLAGS = @TARGET_CLANG_FLAGS@ -Xclang -ffake-address-space-map -emit-llvm -ffp-contract=off
separate_arguments(CELL_TARGET_CLANG_FLAGS)
set(CLANG_FLAGS ${CELL_TARGET_CLANG_FLAGS} "-Xclang" "-ffake-address-space-map" "-emit-llvm" "-ffp-contract=off")

#LLC_FLAGS   = @TARGET_LLC_FLAGS@
separate_arguments(CELL_TARGET_LLC_FLAGS)
set(LLC_FLAGS ${CELL_TARGET_LLC_FLAGS})

# TODO LLC_flags is used by kernel.bc target, but ld is unused
#LD_FLAGS    = @TARGET_LD_FLAGS@

#KERNEL_TARGET = tce (WRONG)
make_kernel_bc(KERNEL_BC "cellspu" ${SOURCES_WITHOUT_VML})

# just debug
message(STATUS "Cell SPU Kernel BC: ${KERNEL_BC}")

# a target is needed...
add_custom_target("kernel_cell" ALL DEPENDS ${KERNEL_BC})

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${KERNEL_BC}"
        DESTINATION "${POCL_INSTALL_PRIVATE_DATADIR}")

=== lib/kernel/cellspu/Makefile ===
# Makefile.in generated by automake 1.11.6 from Makefile.am.
# lib/kernel/cellspu/Makefile.  Generated from Makefile.in by configure.

# Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
# 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011 Free Software
# Foundation, Inc.
# This Makefile.in is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY, to the extent permitted by law; without
# even the implied warranty of MERCHANTABILITY or FITNESS FOR A
# PARTICULAR PURPOSE.



# Process this file with automake to produce Makefile.in
# 
# Copyright (c) 2011 Universidad Rey Juan Carlos
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
# 
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.

# rules.mk - the make rules for building the kernel library
# 
# Copyright (c) 2013 Erik Schnetter
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
# 
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.

# The caller (the Makefile which includes this file) needs to set the
# following variables:
# 
# KERNEL_TARGET
# CLANG_FLAGS
# LLC_FLAGS
# LD_FLAGS

# sources.mk - a list of all kernel source files
# 
# Copyright (c) 2011-2013 Universidad Rey Juan Carlos
#                         Pekka Jääskeläinen / Tampere University of Technology
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
# 
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.


am__make_dryrun = \
  { \
    am__dry=no; \
    case $$MAKEFLAGS in \
      *\\[\ \	]*) \
        echo 'am--echo: ; @echo "AM"  OK' | $(MAKE) -f - 2>/dev/null \
          | grep '^AM OK$$' >/dev/null || am__dry=yes;; \
      *) \
        for am__flg in $$MAKEFLAGS; do \
          case $$am__flg in \
            *=*|--*) ;; \
            *n*) am__dry=yes; break;; \
          esac; \
        done;; \
    esac; \
    test $$am__dry = yes; \
  }
pkgdatadir = $(datadir)/pocl
pkgincludedir = $(includedir)/pocl
pkglibdir = $(libdir)/pocl
pkglibexecdir = $(libexecdir)/pocl
am__cd = CDPATH="$${ZSH_VERSION+.}$(PATH_SEPARATOR)" && cd
install_sh_DATA = $(install_sh) -c -m 644
install_sh_PROGRAM = $(install_sh) -c
install_sh_SCRIPT = $(install_sh) -c
INSTALL_HEADER = $(INSTALL_DATA)
transform = $(program_transform_name)
NORMAL_INSTALL = :
PRE_INSTALL = :
POST_INSTALL = :
NORMAL_UNINSTALL = :
PRE_UNINSTALL = :
POST_UNINSTALL = :
build_triplet = x86_64-unknown-linux-gnu
host_triplet = x86_64-unknown-linux-gnu
target_triplet = x86_64-unknown-linux-gnu
DIST_COMMON = $(srcdir)/../rules.mk $(srcdir)/../sources.mk \
	$(srcdir)/Makefile.am $(srcdir)/Makefile.in
am__append_1 = printf.c
subdir = lib/kernel/cellspu
ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
am__aclocal_m4_deps = $(top_srcdir)/m4/ax_boost_base.m4 \
	$(top_srcdir)/m4/libtool.m4 $(top_srcdir)/m4/ltoptions.m4 \
	$(top_srcdir)/m4/ltsugar.m4 $(top_srcdir)/m4/ltversion.m4 \
	$(top_srcdir)/m4/lt~obsolete.m4 $(top_srcdir)/acinclude.m4 \
	$(top_srcdir)/configure.ac
am__configure_deps = $(am__aclocal_m4_deps) $(CONFIGURE_DEPENDENCIES) \
	$(ACLOCAL_M4)
mkinstalldirs = $(install_sh) -d
CONFIG_HEADER = $(top_builddir)/config.h
CONFIG_CLEAN_FILES =
CONFIG_CLEAN_VPATH_FILES =
AM_V_GEN = $(am__v_GEN_$(V))
am__v_GEN_ = $(am__v_GEN_$(AM_DEFAULT_VERBOSITY))
am__v_GEN_0 = @echo "  GEN   " $@;
AM_V_at = $(am__v_at_$(V))
am__v_at_ = $(am__v_at_$(AM_DEFAULT_VERBOSITY))
am__v_at_0 = @
SOURCES =
DIST_SOURCES =
am__can_run_installinfo = \
  case $$AM_UPDATE_INFO_DIR in \
    n|no|NO) false;; \
    *) (install-info --version) >/dev/null 2>&1;; \
  esac
am__vpath_adj_setup = srcdirstrip=`echo "$(srcdir)" | sed 's|.|.|g'`;
am__vpath_adj = case $$p in \
    $(srcdir)/*) f=`echo "$$p" | sed "s|^$$srcdirstrip/||"`;; \
    *) f=$$p;; \
  esac;
am__strip_dir = f=`echo $$p | sed -e 's|^.*/||'`;
am__install_max = 40
am__nobase_strip_setup = \
  srcdirstrip=`echo "$(srcdir)" | sed 's/[].[^$$\\*|]/\\\\&/g'`
am__nobase_strip = \
  for p in $$list; do echo "$$p"; done | sed -e "s|$$srcdirstrip/||"
am__nobase_list = $(am__nobase_strip_setup); \
  for p in $$list; do echo "$$p $$p"; done | \
  sed "s| $$srcdirstrip/| |;"' / .*\//!s/ .*/ ./; s,\( .*\)/[^/]*$$,\1,' | \
  $(AWK) 'BEGIN { files["."] = "" } { files[$$2] = files[$$2] " " $$1; \
    if (++n[$$2] == $(am__install_max)) \
      { print $$2, files[$$2]; n[$$2] = 0; files[$$2] = "" } } \
    END { for (dir in files) print dir, files[dir] }'
am__base_list = \
  sed '$$!N;$$!N;$$!N;$$!N;$$!N;$$!N;$$!N;s/\n/ /g' | \
  sed '$$!N;$$!N;$$!N;$$!N;s/\n/ /g'
am__uninstall_files_from_dir = { \
  test -z "$$files" \
    || { test ! -d "$$dir" && test ! -f "$$dir" && test ! -r "$$dir"; } \
    || { echo " ( cd '$$dir' && rm -f" $$files ")"; \
         $(am__cd) "$$dir" && rm -f $$files; }; \
  }
am__installdirs = "$(DESTDIR)$(pkgdatadir)"
DATA = $(nodist_pkgdata_DATA)
DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
ACLOCAL = ${SHELL} /home/visit0r/src/pocl-public/config/missing --run aclocal-1.11
AMTAR = $${TAR-tar}
AM_DEFAULT_VERBOSITY = 1
AR = ar
AUTOCONF = ${SHELL} /home/visit0r/src/pocl-public/config/missing --run autoconf
AUTOHEADER = ${SHELL} /home/visit0r/src/pocl-public/config/missing --run autoheader
AUTOMAKE = ${SHELL} /home/visit0r/src/pocl-public/config/missing --run automake-1.11
AWK = gawk
BOOST_CPPFLAGS = -I/usr/include
BOOST_LDFLAGS = -L/usr/lib64
CC = ccache gcc-4.7
CCDEPMODE = depmode=gcc3
CFLAGS = -g -O2
CLANG = /home/visit0r/local/stow/llvm-3.5-opt-tce-patched/bin/clang
CLANGXX = /home/visit0r/local/stow/llvm-3.5-opt-tce-patched/bin/clang++
CLANGXX_FLAGS =  -DVML_NO_IOSTREAM
CLFLAGS =  -D__OPENCL_VERSION__=120
CPP = ccache gcc-4.7 -E
CPPFLAGS = 
CXX = ccache g++-4.7
CXXCPP = ccache g++-4.7 -E
CXXDEPMODE = depmode=gcc3
CXXFLAGS = -g -O3 -Wall -Wextra -Wno-long-long 
CYGPATH_W = echo
DEFS = -DHAVE_CONFIG_H
DEPDIR = .deps
DLLTOOL = false
DSYMUTIL = 
DUMPBIN = 
ECHO_C = 
ECHO_N = -n
ECHO_T = 
EGREP = /bin/grep -E
EXEEXT = 
FGREP = /bin/grep -F
FORCED_CLFLAGS = -Xclang -ffake-address-space-map -fno-math-errno -fblocks -fno-builtin -fasm -Wno-format
GLEW_CFLAGS = -I/usr/include/GL  
GLEW_LIBS = -lGLEW  
GREP = /bin/grep
HOST = x86_64-unknown-linux-gnu
HOST_AS_FLAGS = 
HOST_CLANG_FLAGS =  --target=x86_64-unknown-linux-gnu -march=penryn -D_CL_DISABLE_HALF
HOST_CPU = x86_64
HOST_LD_FLAGS = -shared -lm
HOST_LLC_FLAGS = -relocation-model=pic -mtriple=x86_64-unknown-linux-gnu -mcpu=penryn
HOST_SIZEOF_DOUBLE = 8
HOST_SIZEOF_HALF = 2
HOST_SIZEOF_LONG = 8
HOST_SIZEOF_VOID_P = 8
HWLOC_CFLAGS = -I/usr/include/libxml2  
HWLOC_LIBS = -lhwloc  
ICD_LD_FLAGS = -Wl,-Bsymbolic
INSTALL = /usr/bin/install -c
INSTALL_DATA = ${INSTALL} -m 644
INSTALL_PROGRAM = ${INSTALL}
INSTALL_SCRIPT = ${INSTALL}
INSTALL_STRIP_PROGRAM = $(install_sh) -c -s
KERNEL_COMPILER_LIB_VERSION = 3:0:0
LD = /usr/bin/ld -m elf_x86_64
LDFLAGS = -L/home/visit0r/local/lib
LD_FLAGS_BIN =   -L/home/visit0r/local/stow/tce-trunk-llvm-3.5/lib -ltce
LIBOBJS = 
LIBRARY_SUFFIX = .so
LIBS = 
LIBSPE_CFLAGS = 
LIBSPE_LIBS = 
LIBTOOL = $(SHELL) $(top_builddir)/libtool
LIB_AGE_VERSION = 3
LIB_CURRENT_VERSION = 4
LIB_FIRST_VERSION = 1
LIB_REVISION_VERSION = 0
LIB_VERSION = 4:0:3
LIPO = 
LLC = /home/visit0r/local/stow/llvm-3.5-opt-tce-patched/bin/llc
LLVM_AS = /home/visit0r/local/stow/llvm-3.5-opt-tce-patched/bin/llvm-as
LLVM_CONFIG = /home/visit0r/local/bin/llvm-config
LLVM_CXX_FLAGS = -I/home/visit0r/local/stow/llvm-3.5-opt-tce-patched/include  -D_DEBUG -D_GNU_SOURCE -D__STDC_CONSTANT_MACROS -D__STDC_FORMAT_MACROS -D__STDC_LIMIT_MACROS -O3 -fomit-frame-pointer -std=c++11 -fvisibility-inlines-hidden -fno-exceptions -fPIC -Woverloaded-virtual -ffunction-sections -fdata-sections -Wcast-qual -fno-rtti
LLVM_LDFLAGS = -L/home/visit0r/local/stow/llvm-3.5-opt-tce-patched/lib  -lz -lpthread -ledit -ltinfo -lrt -ldl -lm 
LLVM_LIBS = -lLLVM-3.5.0
LLVM_LINK = /home/visit0r/local/stow/llvm-3.5-opt-tce-patched/bin/llvm-link
LLVM_OPT = /home/visit0r/local/stow/llvm-3.5-opt-tce-patched/bin/opt
LLVM_VERSION = 3.5.0
LN_S = ln -s
LTDL_LIBS = -lltdl 
LTLIBOBJS = 
MAKEINFO = ${SHELL} /home/visit0r/src/pocl-public/config/missing --run makeinfo
MANIFEST_TOOL = :
MKDIR_P = /bin/mkdir -p
NM = /usr/bin/nm -B
NMEDIT = 
OBJDUMP = objdump
OBJEXT = o
OCL_ICD_CFLAGS = 
OCL_ICD_LIBS = 
OCL_KERNEL_ARCH = 
OCL_KERNEL_TARGET = x86_64-unknown-linux-gnu
OCL_KERNEL_TARGET_CPU = penryn
OCL_TARGETS = host tce
OPENCL_CFLAGS = 
OPENCL_CMAKE = 
OPENCL_EXTLIBS = -lOpenCL
OPENCL_LIBS = -lOpenCL
OPT = /home/visit0r/local/stow/llvm-3.5-opt-tce-patched/bin/opt
OTOOL = 
OTOOL64 = 
PACKAGE = pocl
PACKAGE_BUGREPORT = pocl-devel@lists.sourceforge.net
PACKAGE_NAME = pocl
PACKAGE_STRING = pocl 0.10
PACKAGE_TARNAME = pocl
PACKAGE_URL = 
PACKAGE_VERSION = 0.10
PATH_SEPARATOR = :
PKG_CONFIG = /usr/bin/pkg-config
PKG_CONFIG_LIBDIR = 
PKG_CONFIG_PATH = :/home/visit0r/local/lib/pkgconfig:/home/visit0r/local/lib/pkgconfig:/home/visit0r/local/lib/pkgconfig
POAT_TESTSUITES =  viennacl rodinia parboil amd amdsdk2_9 piglit
POCL_DEVICE_ADDRESS_BITS = 64

=== lib/kernel/tce/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2014 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

include("bitcode_rules")

# Use the libc (newlib) printf() for now because the pocl's
# fails in TCE code gen:
# SplitVectorResult #0: 0x24c5ae0: v8i16,ch = vaarg 0x20628e8, 0x2423ed0, 0x24c59e0, 0x24c4fe0 [ORD=223] [ID=0]
# LLVM ERROR: Do not know how to split the result of this operator!
if(NEW_PRINTF_WORKS)
  list(REMOVE_ITEM SOURCES_WITHOUT_VML "printf.c")
  list(APPEND SOURCES_WITHOUT_VML "printf_constant.c")
endif()



# Use TARGET flags:
# with some additional CLANG_FLAGS
#CLANG_FLAGS = @TARGET_CLANG_FLAGS@ -Xclang -ffake-address-space-map -emit-llvm -ffp-contract=off
separate_arguments(TCE_TARGET_CLANG_FLAGS)
set(CLANG_FLAGS ${TCE_TARGET_CLANG_FLAGS} "-Xclang" "-ffake-address-space-map" "-emit-llvm" "-ffp-contract=off" "-target" "tce-tut-llvm" "-isystem" "${TCE_PREFIX}/tce-llvm/include")

#LLC_FLAGS   = @TARGET_LLC_FLAGS@
separate_arguments(TCE_TARGET_LLC_FLAGS)
set(LLC_FLAGS ${TCE_TARGET_LLC_FLAGS})

# TODO LLC_flags is used by kernel.bc target, but ld is unused
#LD_FLAGS    = @TARGET_LD_FLAGS@

#KERNEL_TARGET = tce (WRONG)
make_kernel_bc(KERNEL_BC "tce-tut-llvm" ${SOURCES_WITHOUT_VML})

# just debug
message(STATUS "TCE Kernel BC: ${KERNEL_BC}")

# a target is needed...
add_custom_target("kernel_tce" ALL DEPENDS ${KERNEL_BC})

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${KERNEL_BC}"
        DESTINATION "${POCL_INSTALL_PRIVATE_DATADIR}")

=== lib/kernel/tce/Makefile ===
# Makefile.in generated by automake 1.11.6 from Makefile.am.
# lib/kernel/tce/Makefile.  Generated from Makefile.in by configure.

# Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
# 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011 Free Software
# Foundation, Inc.
# This Makefile.in is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY, to the extent permitted by law; without
# even the implied warranty of MERCHANTABILITY or FITNESS FOR A
# PARTICULAR PURPOSE.



# Process this file with automake to produce Makefile.in
# 
# Copyright (c) 2011 Universidad Rey Juan Carlos
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
# 
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.

# rules.mk - the make rules for building the kernel library
# 
# Copyright (c) 2013 Erik Schnetter
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
# 
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.

# The caller (the Makefile which includes this file) needs to set the
# following variables:
# 
# KERNEL_TARGET
# CLANG_FLAGS
# LLC_FLAGS
# LD_FLAGS

# sources.mk - a list of all kernel source files
# 
# Copyright (c) 2011-2013 Universidad Rey Juan Carlos
#                         Pekka Jääskeläinen / Tampere University of Technology
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
# 
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.


am__make_dryrun = \
  { \
    am__dry=no; \
    case $$MAKEFLAGS in \
      *\\[\ \	]*) \
        echo 'am--echo: ; @echo "AM"  OK' | $(MAKE) -f - 2>/dev/null \
          | grep '^AM OK$$' >/dev/null || am__dry=yes;; \
      *) \
        for am__flg in $$MAKEFLAGS; do \
          case $$am__flg in \
            *=*|--*) ;; \
            *n*) am__dry=yes; break;; \
          esac; \
        done;; \
    esac; \
    test $$am__dry = yes; \
  }
pkgdatadir = $(datadir)/pocl
pkgincludedir = $(includedir)/pocl
pkglibdir = $(libdir)/pocl
pkglibexecdir = $(libexecdir)/pocl
am__cd = CDPATH="$${ZSH_VERSION+.}$(PATH_SEPARATOR)" && cd
install_sh_DATA = $(install_sh) -c -m 644
install_sh_PROGRAM = $(install_sh) -c
install_sh_SCRIPT = $(install_sh) -c
INSTALL_HEADER = $(INSTALL_DATA)
transform = $(program_transform_name)
NORMAL_INSTALL = :
PRE_INSTALL = :
POST_INSTALL = :
NORMAL_UNINSTALL = :
PRE_UNINSTALL = :
POST_UNINSTALL = :
build_triplet = x86_64-unknown-linux-gnu
host_triplet = x86_64-unknown-linux-gnu
target_triplet = x86_64-unknown-linux-gnu
DIST_COMMON = $(srcdir)/../rules.mk $(srcdir)/../sources.mk \
	$(srcdir)/Makefile.am $(srcdir)/Makefile.in
am__append_1 = printf.c
subdir = lib/kernel/tce
ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
am__aclocal_m4_deps = $(top_srcdir)/m4/ax_boost_base.m4 \
	$(top_srcdir)/m4/libtool.m4 $(top_srcdir)/m4/ltoptions.m4 \
	$(top_srcdir)/m4/ltsugar.m4 $(top_srcdir)/m4/ltversion.m4 \
	$(top_srcdir)/m4/lt~obsolete.m4 $(top_srcdir)/acinclude.m4 \
	$(top_srcdir)/configure.ac
am__configure_deps = $(am__aclocal_m4_deps) $(CONFIGURE_DEPENDENCIES) \
	$(ACLOCAL_M4)
mkinstalldirs = $(install_sh) -d
CONFIG_HEADER = $(top_builddir)/config.h
CONFIG_CLEAN_FILES =
CONFIG_CLEAN_VPATH_FILES =
AM_V_GEN = $(am__v_GEN_$(V))
am__v_GEN_ = $(am__v_GEN_$(AM_DEFAULT_VERBOSITY))
am__v_GEN_0 = @echo "  GEN   " $@;
AM_V_at = $(am__v_at_$(V))
am__v_at_ = $(am__v_at_$(AM_DEFAULT_VERBOSITY))
am__v_at_0 = @
SOURCES =
DIST_SOURCES =
am__can_run_installinfo = \
  case $$AM_UPDATE_INFO_DIR in \
    n|no|NO) false;; \
    *) (install-info --version) >/dev/null 2>&1;; \
  esac
am__vpath_adj_setup = srcdirstrip=`echo "$(srcdir)" | sed 's|.|.|g'`;
am__vpath_adj = case $$p in \
    $(srcdir)/*) f=`echo "$$p" | sed "s|^$$srcdirstrip/||"`;; \
    *) f=$$p;; \
  esac;
am__strip_dir = f=`echo $$p | sed -e 's|^.*/||'`;
am__install_max = 40
am__nobase_strip_setup = \
  srcdirstrip=`echo "$(srcdir)" | sed 's/[].[^$$\\*|]/\\\\&/g'`
am__nobase_strip = \
  for p in $$list; do echo "$$p"; done | sed -e "s|$$srcdirstrip/||"
am__nobase_list = $(am__nobase_strip_setup); \
  for p in $$list; do echo "$$p $$p"; done | \
  sed "s| $$srcdirstrip/| |;"' / .*\//!s/ .*/ ./; s,\( .*\)/[^/]*$$,\1,' | \
  $(AWK) 'BEGIN { files["."] = "" } { files[$$2] = files[$$2] " " $$1; \
    if (++n[$$2] == $(am__install_max)) \
      { print $$2, files[$$2]; n[$$2] = 0; files[$$2] = "" } } \
    END { for (dir in files) print dir, files[dir] }'
am__base_list = \
  sed '$$!N;$$!N;$$!N;$$!N;$$!N;$$!N;$$!N;s/\n/ /g' | \
  sed '$$!N;$$!N;$$!N;$$!N;s/\n/ /g'
am__uninstall_files_from_dir = { \
  test -z "$$files" \
    || { test ! -d "$$dir" && test ! -f "$$dir" && test ! -r "$$dir"; } \
    || { echo " ( cd '$$dir' && rm -f" $$files ")"; \
         $(am__cd) "$$dir" && rm -f $$files; }; \
  }
am__installdirs = "$(DESTDIR)$(pkgdatadir)"
DATA = $(nodist_pkgdata_DATA)
DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
ACLOCAL = ${SHELL} /home/visit0r/src/pocl-public/config/missing --run aclocal-1.11
AMTAR = $${TAR-tar}
AM_DEFAULT_VERBOSITY = 1
AR = ar
AUTOCONF = ${SHELL} /home/visit0r/src/pocl-public/config/missing --run autoconf
AUTOHEADER = ${SHELL} /home/visit0r/src/pocl-public/config/missing --run autoheader
AUTOMAKE = ${SHELL} /home/visit0r/src/pocl-public/config/missing --run automake-1.11
AWK = gawk
BOOST_CPPFLAGS = -I/usr/include
BOOST_LDFLAGS = -L/usr/lib64
CC = ccache gcc-4.7
CCDEPMODE = depmode=gcc3
CFLAGS = -g -O2
CLANG = /home/visit0r/local/stow/llvm-3.5-opt-tce-patched/bin/clang
CLANGXX = /home/visit0r/local/stow/llvm-3.5-opt-tce-patched/bin/clang++
CLANGXX_FLAGS =  -DVML_NO_IOSTREAM
CLFLAGS =  -D__OPENCL_VERSION__=120
CPP = ccache gcc-4.7 -E
CPPFLAGS = 
CXX = ccache g++-4.7
CXXCPP = ccache g++-4.7 -E
CXXDEPMODE = depmode=gcc3
CXXFLAGS = -g -O3 -Wall -Wextra -Wno-long-long 
CYGPATH_W = echo
DEFS = -DHAVE_CONFIG_H
DEPDIR = .deps
DLLTOOL = false
DSYMUTIL = 
DUMPBIN = 
ECHO_C = 
ECHO_N = -n
ECHO_T = 
EGREP = /bin/grep -E
EXEEXT = 
FGREP = /bin/grep -F
FORCED_CLFLAGS = -Xclang -ffake-address-space-map -fno-math-errno -fblocks -fno-builtin -fasm -Wno-format
GLEW_CFLAGS = -I/usr/include/GL  
GLEW_LIBS = -lGLEW  
GREP = /bin/grep
HOST = x86_64-unknown-linux-gnu
HOST_AS_FLAGS = 
HOST_CLANG_FLAGS =  --target=x86_64-unknown-linux-gnu -march=penryn -D_CL_DISABLE_HALF
HOST_CPU = x86_64
HOST_LD_FLAGS = -shared -lm
HOST_LLC_FLAGS = -relocation-model=pic -mtriple=x86_64-unknown-linux-gnu -mcpu=penryn
HOST_SIZEOF_DOUBLE = 8
HOST_SIZEOF_HALF = 2
HOST_SIZEOF_LONG = 8
HOST_SIZEOF_VOID_P = 8
HWLOC_CFLAGS = -I/usr/include/libxml2  
HWLOC_LIBS = -lhwloc  
ICD_LD_FLAGS = -Wl,-Bsymbolic
INSTALL = /usr/bin/install -c
INSTALL_DATA = ${INSTALL} -m 644
INSTALL_PROGRAM = ${INSTALL}
INSTALL_SCRIPT = ${INSTALL}
INSTALL_STRIP_PROGRAM = $(install_sh) -c -s
KERNEL_COMPILER_LIB_VERSION = 3:0:0
LD = /usr/bin/ld -m elf_x86_64
LDFLAGS = -L/home/visit0r/local/lib
LD_FLAGS_BIN =   -L/home/visit0r/local/stow/tce-trunk-llvm-3.5/lib -ltce
LIBOBJS = 
LIBRARY_SUFFIX = .so
LIBS = 
LIBSPE_CFLAGS = 
LIBSPE_LIBS = 
LIBTOOL = $(SHELL) $(top_builddir)/libtool
LIB_AGE_VERSION = 3
LIB_CURRENT_VERSION = 4
LIB_FIRST_VERSION = 1
LIB_REVISION_VERSION = 0
LIB_VERSION = 4:0:3
LIPO = 
LLC = /home/visit0r/local/stow/llvm-3.5-opt-tce-patched/bin/llc
LLVM_AS = /home/visit0r/local/stow/llvm-3.5-opt-tce-patched/bin/llvm-as
LLVM_CONFIG = /home/visit0r/local/bin/llvm-config
LLVM_CXX_FLAGS = -I/home/visit0r/local/stow/llvm-3.5-opt-tce-patched/include  -D_DEBUG -D_GNU_SOURCE -D__STDC_CONSTANT_MACROS -D__STDC_FORMAT_MACROS -D__STDC_LIMIT_MACROS -O3 -fomit-frame-pointer -std=c++11 -fvisibility-inlines-hidden -fno-exceptions -fPIC -Woverloaded-virtual -ffunction-sections -fdata-sections -Wcast-qual -fno-rtti
LLVM_LDFLAGS = -L/home/visit0r/local/stow/llvm-3.5-opt-tce-patched/lib  -lz -lpthread -ledit -ltinfo -lrt -ldl -lm 
LLVM_LIBS = -lLLVM-3.5.0
LLVM_LINK = /home/visit0r/local/stow/llvm-3.5-opt-tce-patched/bin/llvm-link
LLVM_OPT = /home/visit0r/local/stow/llvm-3.5-opt-tce-patched/bin/opt
LLVM_VERSION = 3.5.0
LN_S = ln -s
LTDL_LIBS = -lltdl 
LTLIBOBJS = 
MAKEINFO = ${SHELL} /home/visit0r/src/pocl-public/config/missing --run makeinfo
MANIFEST_TOOL = :
MKDIR_P = /bin/mkdir -p
NM = /usr/bin/nm -B
NMEDIT = 
OBJDUMP = objdump
OBJEXT = o
OCL_ICD_CFLAGS = 
OCL_ICD_LIBS = 
OCL_KERNEL_ARCH = 
OCL_KERNEL_TARGET = x86_64-unknown-linux-gnu
OCL_KERNEL_TARGET_CPU = penryn
OCL_TARGETS = host tce
OPENCL_CFLAGS = 
OPENCL_CMAKE = 
OPENCL_EXTLIBS = -lOpenCL
OPENCL_LIBS = -lOpenCL
OPT = /home/visit0r/local/stow/llvm-3.5-opt-tce-patched/bin/opt
OTOOL = 
OTOOL64 = 
PACKAGE = pocl
PACKAGE_BUGREPORT = pocl-devel@lists.sourceforge.net
PACKAGE_NAME = pocl
PACKAGE_STRING = pocl 0.10
PACKAGE_TARNAME = pocl
PACKAGE_URL = 
PACKAGE_VERSION = 0.10
PATH_SEPARATOR = :
PKG_CONFIG = /usr/bin/pkg-config
PKG_CONFIG_LIBDIR = 
PKG_CONFIG_PATH = :/home/visit0r/local/lib/pkgconfig:/home/visit0r/local/lib/pkgconfig:/home/visit0r/local/lib/pkgconfig
POAT_TESTSUITES =  viennacl rodinia parboil amd amdsdk2_9 piglit
POCL_DEVICE_ADDRESS_BITS = 64

=== debian/changelog ===
pocl (0.10-10) unstable; urgency=medium

  * fix symbol file (again), perhaps due to previous target adjustment
  * trying pentium-m (for i386) and nehalem (for freebsd-i386) as
    processor target

 -- Vincent Danjean <vdanjean@debian.org>  Sat, 25 Oct 2014 22:32:40 +0200

pocl (0.10-9) unstable; urgency=medium

  * fix symbol file (again)
  * lowering armhf llvm target (cortex-a5 instead of cortex-a7)
    The good one should be ARMv7-A but it does not exist in LLVM
    https://wiki.debian.org/ArmHardFloatPort
  * bumping i386 target (from i686 to pentium4)
    => some officially Debian supported i386 systems wont work with
    pocl

 -- Vincent Danjean <vdanjean@debian.org>  Fri, 24 Oct 2014 14:20:00 +0200

pocl (0.10-8) unstable; urgency=medium

  * fix symbol file for other architecture (!amd64)

 -- Vincent Danjean <vdanjean@debian.org>  Fri, 24 Oct 2014 08:09:48 +0200

pocl (0.10-7) unstable; urgency=medium

  * bump minimum arch on i386 (from i586 to i686)
  * to not ignore failed testsuite anymore at build time

 -- Vincent Danjean <vdanjean@debian.org>  Wed, 22 Oct 2014 21:07:51 +0200

pocl (0.10-6) unstable; urgency=medium

  * Fix OpenCL headers for i386 FreeBSD
  * use pkg-kde-tools to handle C++ symbols
  * Try to support more Debian architectures.

 -- Vincent Danjean <vdanjean@debian.org>  Wed, 22 Oct 2014 12:31:11 +0200

pocl (0.10-5) unstable; urgency=medium

  * Fix arm configure.ac detection
  * try to support more Debian architectures

 -- Vincent Danjean <vdanjean@debian.org>  Tue, 21 Oct 2014 14:50:28 +0200

pocl (0.10-4) unstable; urgency=medium

  * No need to provide utlist.h that is already provided in the uthash-dev
    package (Closes: #764571)
  * Fix some glitches in descriptions
  * Remove old unneeded patches
  * Add clang-3.5 dependency for libpocl1 (required when running a kernel)
  * Fix default host CPU for the OpenCL compiler
  * Add info in build logs to help debugging

 -- Vincent Danjean <vdanjean@debian.org>  Fri, 10 Oct 2014 22:23:38 +0200

pocl (0.10-3) unstable; urgency=medium

  * Move the manpage in the correct package

 -- Vincent Danjean <vdanjean@debian.org>  Wed, 08 Oct 2014 00:03:28 +0200

pocl (0.10-2) unstable; urgency=medium

  * Fix URLs, project name and update the copyright list
    (initially created in 2012 with 0.7 version)

 -- Vincent Danjean <vdanjean@debian.org>  Mon, 06 Oct 2014 23:22:34 +0200

pocl (0.10-1) unstable; urgency=medium

  * Initial release. (Closes: #676504: ITP: pocl -- Portable OpenCL)

 -- Vincent Danjean <vdanjean@debian.org>  Sun, 05 Oct 2014 21:15:18 +0200

=== debian/control ===
Source: pocl
Section: devel
Priority: extra
Maintainer: Vincent Danjean <vdanjean@debian.org>
Build-Depends: debhelper (>= 9~), autotools-dev, autoconf, dh-autoreconf,
 pkg-config, libhwloc-dev, libltdl-dev, mesa-common-dev,
 ocl-icd-dev (>=2.2.3), ocl-icd-libopencl1 (>=2.2.3), ocl-icd-opencl-dev,
 libedit-dev, libz-dev,
 clang, llvm-3.5-dev, libclang-3.5-dev,
 pkg-kde-tools
Standards-Version: 3.9.6
Homepage: http://portablecl.org
Vcs-Git: git://anonscm.debian.org/collab-maint/pocl.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/pocl.git;a=summary

Package: pocl-opencl-icd
Architecture: any
Provides: opencl-icd, opencl-icd-1.1-1, opencl-icd-1.2-1
Section: libs
Depends: ${misc:Depends}, libpocl1 (= ${binary:Version})
Description: pocl ICD
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package allows one to use pocl as an installable client driver (ICD) for
 OpenCL.

Package: libpocl1-common
Architecture: all
Section: libs
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: common files for the pocl library
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package provides the architecture independent files of the pocl library.

Package: libpocl1
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, libpocl1-common (= ${source:Version}),
  clang-3.5
Recommends: pocl-opencl-icd
Description: Portable Computing Language library
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package provides the core of pocl.

Package: libpoclu1
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: utility library for writing OpenCL programs
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package provides an small utility library to help writing OpenCL
 programs.

Package: libpoclu-dev
Architecture: any
Section: libdevel
Multi-Arch: foreign
Depends: ${misc:Depends}, libpoclu1 (= ${binary:Version}), opencl-headers (>= 1.2)
Recommends: ocl-icd-opencl-dev
Description: development files for the pocl utility library
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package provides the development files for the pocl utility library,
 that provides various facilities to write OpenCL programs.

Package: libpocl-dev
Architecture: any
Section: libdevel
Multi-Arch: foreign
Depends: ${misc:Depends}, libpocl1 (= ${binary:Version})
Description: development files for the pocl library
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package provides the development files for the pocl library.  Unless very
 specific needs, this package is useless.  This package is only required to link
 directly and explicitly with pocl.
 .
 To develop OpenCL programs (that can be run with pocl), the opencl-dev virtual
 package (provided by ocl-icd-opencl-dev for example) is required, not this one.

Package: libpocl-dbg
Architecture: any
Section: debug
Multi-Arch: same
Depends: ${misc:Depends}, libpocl1 (= ${binary:Version})
Description: debugging symbols for pocl
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package contains the debugging symbols for libpocl1 and libpoclu0.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DEB_HOST_ARCH?=$(shell dpkg-architecture -qDEB_HOST_ARCH)
LLVM_ARCH=$(shell sed < debian/supported-archs \
	-e '/^DEB_ARCH: $(DEB_HOST_ARCH)$$/,/^ *$$/p;d' \
	| sed -e 's/^LLVM_ARCH=//p;d')

ifeq ($(LLVM_ARCH),)
else
export LLC_HOST_CPU=$(LLVM_ARCH)
endif

# doc for symbols:
# http://www.eyrie.org/~eagle/journal/2012-01/008.html
# main packaging script based on dh7 syntax
%:
	dh $@  --with autotools-dev --parallel --with pkgkde_symbolshelper

.PHONY: override_dh_auto_configure override_dh_shlibdeps override_dh_install
.PHONY: override_dh_strip override_dh_auto_test override_dh_makeshlibs
override_dh_auto_configure:
ifeq ($(LLVM_ARCH),)
	$(warning Experimental architecture. Build failure expected)
endif
	@echo Using LLC_HOST_CPU=$${LLC_HOST_CPU}
	-/usr/lib/llvm-3.5/bin/llc -mattr=help
	autoreconf -vif -Wall -Wno-obsolete
	dh_auto_configure -- --enable-icd --disable-static \
		LLVM_CONFIG=/usr/bin/llvm-config-3.5

override_dh_shlibdeps:
	dh_shlibdeps -a -- --warnings=7

override_dh_install:
	sed -i debian/tmp/etc/OpenCL/vendors/pocl.icd \
		-e 's,.*/\([^/.]*\.so\.[^/.]*\)\.[^/]*,\1,'
	dh_install --list-missing -Xusr/include/CL/ -X.la -Xusr/include/utlist.h

override_dh_strip:
	dh_strip --dbg-package=libpocl-dbg

override_dh_auto_test:
	# Failure in testsuite is delayed until symbols handling
	# and all files are logged.
	$(RM) debian/stamp-failed-testsuite
	if ! dh_auto_test ; then \
		for f in $$(find tests/testsuite.dir -type f); do \
			echo "******************************************" ;\
			echo "* File: $$f" ;\
			echo "******************************************" ;\
			cat $$f ;\
			echo "******************************************" ;\
		done ;\
		touch debian/stamp-failed-testsuite; \
	fi

override_dh_makeshlibs:
	dh_makeshlibs
	if test -f debian/stamp-failed-testsuite ; then \
		grep '^ .*FAILED' < tests/testsuite.log ; \
		exit 1 ; \
	fi

fix-symbols:
	pkgkde-getbuildlogs
	echo pkgkde-symbolshelper batchpatch -v 0.10 pocl_unstable_logs/pocl_0.10-9_*build

=== debian/watch ===
version=3

opts=uversionmangle=s/((alpha|beta|rc)\d*)/~$1/ \
https://launchpad.net/pocl/+download https://launchpad.net/pocl/[\d.]+/[\d.rcalphbet]+/\+download/pocl-([\d.rcalphbet]+).tar.gz
opts=uversionmangle=s/((alpha|beta|rc)\d*)/~$1/ \
http://pocl.sourceforge.net/downloads/pocl-([\d.rcalphbet]+).tar.gz
